package com.zhengyiyu.common;

import java.io.File;

/**
 * @author Yiyu
 * This class will list all the useful folder, and even for web page usage, now all the folder path are the full path
 * each folder should be end with a file separator
 */

public class FolderPath {
	
	private static String PROJECT_NAME = "ffn";

	public static void main(String[] args) {
		System.out.println(WORKSPACE_FOLDER);
		System.out.println(PROJECT_FOLDER_FULL);
	}

	/**
	 * if working on tomcat model, the default folder will be the root folder of tomcat, we need to manually fix it, 
	 * it will not affect when running in the cluster so we do not need to consider it currently. 
	 */
	public static String REALFOLDER = new File(".").getAbsolutePath().contains(":") ? "D:\\workspace_java\\" : "/home/yiyu/workspace_java/";
	
	/**
	 * The java workspace folder
	 */
	public static String WORKSPACE_FOLDER = new File(".").getAbsolutePath().contains("tomcat") || new File(".").getAbsolutePath().contains("git") ? REALFOLDER : new File(new File(".").getAbsolutePath()).getParentFile().getParent() + File.separator;
	
	/**
	 * The root folder of the report project
	 */
	public static String PROJECT_FOLDER_FULL = WORKSPACE_FOLDER + PROJECT_NAME + File.separator;
	
	/**
	 * where result data is stored, usually there data are generated by this project and not for display
	 */
	public static String OUTPUT_FOLDER_Full = PROJECT_FOLDER_FULL + File.separator + "output" + File.separator;

	/*
	 * The following is the folder the of usefull folder
	 */
	
	/**
	 * human hg18 sequence file, 10w bp per line
	 */
	public static String HumanChrFile_Folder_10W = FolderPath.OUTPUT_FOLDER_Full + "chr_hg18_10w" + File.separator;
	
}
