/**
 * 
 */
package com.zhengyiyu.obj;

/**
 * @author yiyu
 * for DNA sequence there are two strand, forward/plus/+ and reverse/minus/- strand
 */
public enum Strand {
	Plus("+"), Minus("-");
	
	private final String sign; 
	
	private Strand(String sign) {
		this.sign = sign;
	}

	
	@Override
	public String toString() {
		return sign;
	};
	
	/**
	 * @param sign
	 * @return the corresponding strand
	 * based on the sign, get the strand
	 */
	public static Strand getStrand(String sign) {
		for (Strand strand : Strand.values()) {
			if (strand.sign.equals(sign)) {
				return strand;
			}
		}
		
		// everything not on the minus strand is considered in the plus strand
		return Plus;
	}
}
