package com.zhengyiyu.util;

import com.zhengyiyu.obj.Nucleosome;
import com.zhengyiyu.obj.Sequence;

public class StringUtil {
	
	public static Sequence convertChrCompact2SequencePostion(String chrCompact) {
		if (chrCompact == null || chrCompact == "") {
			return null;
		}
		
		int colonPosition = chrCompact.indexOf(":");
		int minusSignPostion = chrCompact.indexOf("-");
		
		if (colonPosition == -1 || minusSignPostion == -1) {
			System.out.println(chrCompact + " does not match format 'chrName:start-end' :" + chrCompact);
			return null;
		}
		
		String chr = new String(chrCompact.substring(0, colonPosition));
		String start = new String(chrCompact.substring(colonPosition + 1, minusSignPostion));
		String end = new String(chrCompact.substring(minusSignPostion + 1));
		
		return new Sequence(chr, Integer.parseInt(start), Integer.parseInt(end));
	}
	
	public static String convertChrCompact2Bed(String chrCompact) {
		if (chrCompact == null || chrCompact == "") {
			return "";
		}
		
		int colonPosition = chrCompact.indexOf(":");
		int minusSignPostion = chrCompact.indexOf("-");
		
		if (colonPosition == -1 || minusSignPostion == -1) {
			System.out.println(chrCompact + " does not match format 'chrName:start-end'");
			return "";
		}
		
		String chr = chrCompact.substring(0, colonPosition);
		String start = chrCompact.substring(colonPosition + 1, minusSignPostion);
		String end = chrCompact.substring(minusSignPostion + 1);
		
		String result = chr.substring(3) + "\t" + start + "\t" + end;
		
		return result;
	}

	/**
	 * @param string
	 * @param start
	 * @param end
	 * @return the sequence start from start and end in end [start, end)
	 * 
	 * just avert the memory leak of String.subString
	 */
	public static String subString(String string, int start, int end) {
		int length = end - start;
		char[] dest = new char[length];
		System.arraycopy(string.toCharArray(), start, dest, 0, length);
		return new String(dest);
	}

	public static boolean containsTandemRepeatMask(String content) {
		if (content == null || content.equals("")) {
			System.out.println("A null or blank input");
			return false;
		}
		
		// N is repeat masked, and small cap acgt is tandem repeat
		if (content.contains("a") || content.contains("c") || content.contains("g") || content.contains("t")) {
			// System.out.println("Containing Tandem Repeat!");
			return true;
		}
		
		return false;
	}
	
	public static boolean containsRepeatMaskN(String content) {
		if (content == null || content.equals("")) {
			System.out.println("A null or blank input");
			return false;
		}
		
		if (content.contains("N")) {
			System.out.println("Containing Repeat Mask!");
			return true;
		}
		
		return false;
	}

	public static Nucleosome convertChrCompact2Nucleosome(String chr, String chrCompact, int nucleosomeStatus) {
		if (chrCompact == null || chrCompact == "") {
			return null;
		}
		
		int colonPosition = chrCompact.indexOf(":");
		int minusSignPostion = chrCompact.indexOf("-");
		
		if (colonPosition == -1 || minusSignPostion == -1) {
			System.out.println(chrCompact + " does not match format 'chrName:start-end' :" + chrCompact);
			return null;
		}
		
		String start = new String(chrCompact.substring(colonPosition + 1, minusSignPostion));
		String end = new String(chrCompact.substring(minusSignPostion + 1));
		
		return new Nucleosome(chr == null ? new String(chrCompact.substring(0, colonPosition)) : chr, Integer.parseInt(start), Integer.parseInt(end), nucleosomeStatus);
	}
	
	public static String getIndexString(char index) {
		if (index <= 'Z') {
			return index + "";
		}
		return "" + (char)(index + 6);
	}
	

}
